/*************************************************************/
/* Copyright (C) 2011 OSS Nokalva, Inc.  All rights reserved.*/
/*************************************************************/

/* THIS FILE IS PROPRIETARY MATERIAL OF OSS NOKALVA, INC.
 * AND MAY BE USED ONLY BY DIRECT LICENSEES OF OSS NOKALVA, INC.
 * THIS FILE MAY NOT BE DISTRIBUTED. */

/* Generated for: Testing Technologies IST GmbH, Berlin, Germany - License 11335 on Linux */
/* Abstract syntax: cam */
/* ASN.1 Java project: org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.Libitscam_asn1 */
/* Created: Fri Apr 15 16:16:01 2011 */
/* ASN.1 Compiler for Java version: 4.0 */
/* ASN.1 compiler options and file names specified:
 * -output org.etsi.its.codec.tool.testingtech.LibItsCam_asn1 -nolistingfile
 * -nomodlistingfile -shortennames -constraints -nouserconstraints -valuerefs
 * -debug -nopedantic -noinformatorymessages -uper -root -keepnames
 * -norelaySafe -noparamtypesuperclass -jiaapi -autoencdec -messageFormat emacs
 * /tmp/TTthree-dte/oss20212gen/LibItsCam_asn1.gen DENM.asn CAM.asn
 */


package org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.denm_pdu_descriptions;

import com.oss.asn1.*;
import com.oss.metadata.*;
import org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.*;

/**
 * Define the ASN1 Type PTLineDescription from ASN1 Module DENM_PDU_Descriptions.
 * @see Sequence
 */

public class PTLineDescription extends Sequence {
    
    /**
     * The default constructor.
     */
    public PTLineDescription()
    {
    }
    
    /**
     * Construct with AbstractData components.
     */
    public PTLineDescription(CourseOfJourney courseOfJourney, LineRef lineRef, 
		    RouteRef routeRef)
    {
	setCourseOfJourney(courseOfJourney);
	setLineRef(lineRef);
	setRouteRef(routeRef);
    }
    
    public void initComponents()
    {
	mComponents[0] = new CourseOfJourney();
	mComponents[1] = new LineRef();
	mComponents[2] = new RouteRef();
    }
    
    // Instance initializer
    {
	mComponents = new AbstractData[3];
    }
    
    // Method to create a specific component instance
    public AbstractData createInstance(int index)
    {
	switch (index) {
	    case 0:
		return new CourseOfJourney();
	    case 1:
		return new LineRef();
	    case 2:
		return new RouteRef();
	    default:
		throw new InternalError("AbstractCollection.createInstance()");
	}
	
    }
    
    
    // Methods for field "courseOfJourney"
    public CourseOfJourney getCourseOfJourney()
    {
	return (CourseOfJourney)mComponents[0];
    }
    
    public void setCourseOfJourney(CourseOfJourney courseOfJourney)
    {
	mComponents[0] = courseOfJourney;
    }
    
    
    // Methods for field "lineRef"
    public LineRef getLineRef()
    {
	return (LineRef)mComponents[1];
    }
    
    public void setLineRef(LineRef lineRef)
    {
	mComponents[1] = lineRef;
    }
    
    
    // Methods for field "routeRef"
    public RouteRef getRouteRef()
    {
	return (RouteRef)mComponents[2];
    }
    
    public void setRouteRef(RouteRef routeRef)
    {
	mComponents[2] = routeRef;
    }
    
    
    /**
     * Initialize the type descriptor.
     */
    private static final SequenceInfo c_typeinfo = new SequenceInfo (
	new Tags (
	    new short[] {
		0x0010
	    }
	),
	new QName (
	    "org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.denm_pdu_descriptions",
	    "PTLineDescription"
	),
	new QName (
	    "DENM-PDU-Descriptions",
	    "PTLineDescription"
	),
	12314,
	null,
	new Fields (
	    new SequenceFieldInfo[] {
		new SequenceFieldInfo (
		    new TypeInfoRef (
			new KMCStringInfo (
			    new Tags (
				new short[] {
				    (short)0x8000
				}
			    ),
			    new QName (
				"org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.denm_pdu_descriptions",
				"CourseOfJourney"
			    ),
			    new QName (
				"DENM-PDU-Descriptions",
				"CourseOfJourney"
			    ),
			    12314,
			    new Intersection (
				new SizeConstraint (
				    new ValueRangeConstraint (
					new AbstractBounds(
					    new com.oss.asn1.INTEGER(0), 
					    new com.oss.asn1.INTEGER(32),
					    0
					)
				    )
				),
				new PermittedAlphabetConstraint (
				    IA5StringPAInfo.pa
				)
			    ),
			    new Bounds (
				new java.lang.Long(0),
				new java.lang.Long(32)
			    ),
			    IA5StringPAInfo.paInfo
			)
		    ),
		    "courseOfJourney",
		    0,
		    2,
		    null
		),
		new SequenceFieldInfo (
		    new TypeInfoRef (
			new KMCStringInfo (
			    new Tags (
				new short[] {
				    (short)0x8001
				}
			    ),
			    new QName (
				"org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.denm_pdu_descriptions",
				"LineRef"
			    ),
			    new QName (
				"DENM-PDU-Descriptions",
				"LineRef"
			    ),
			    12314,
			    new Intersection (
				new SizeConstraint (
				    new ValueRangeConstraint (
					new AbstractBounds(
					    new com.oss.asn1.INTEGER(0), 
					    new com.oss.asn1.INTEGER(32),
					    0
					)
				    )
				),
				new PermittedAlphabetConstraint (
				    IA5StringPAInfo.pa
				)
			    ),
			    new Bounds (
				new java.lang.Long(0),
				new java.lang.Long(32)
			    ),
			    IA5StringPAInfo.paInfo
			)
		    ),
		    "lineRef",
		    1,
		    2,
		    null
		),
		new SequenceFieldInfo (
		    new TypeInfoRef (
			new KMCStringInfo (
			    new Tags (
				new short[] {
				    (short)0x8002
				}
			    ),
			    new QName (
				"org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.denm_pdu_descriptions",
				"RouteRef"
			    ),
			    new QName (
				"DENM-PDU-Descriptions",
				"RouteRef"
			    ),
			    12314,
			    new Intersection (
				new SizeConstraint (
				    new ValueRangeConstraint (
					new AbstractBounds(
					    new com.oss.asn1.INTEGER(0), 
					    new com.oss.asn1.INTEGER(32),
					    0
					)
				    )
				),
				new PermittedAlphabetConstraint (
				    IA5StringPAInfo.pa
				)
			    ),
			    new Bounds (
				new java.lang.Long(0),
				new java.lang.Long(32)
			    ),
			    IA5StringPAInfo.paInfo
			)
		    ),
		    "routeRef",
		    2,
		    2,
		    null
		)
	    }
	),
	0,
	new TagDecoders (
	    new TagDecoder[] {
		new TagDecoder (
		    new TagDecoderElement[] {
			new TagDecoderElement((short)0x8000, 0)
		    }
		),
		new TagDecoder (
		    new TagDecoderElement[] {
			new TagDecoderElement((short)0x8001, 1)
		    }
		),
		new TagDecoder (
		    new TagDecoderElement[] {
			new TagDecoderElement((short)0x8002, 2)
		    }
		)
	    }
	),
	0
    );
    
    /**
     * Get the type descriptor (TypeInfo) of 'this' PTLineDescription object.
     */
    public TypeInfo getTypeInfo()
    {
	return c_typeinfo;
    }
    
    /**
     * Get the static type descriptor (TypeInfo) of 'this' PTLineDescription object.
     */
    public static TypeInfo getStaticTypeInfo()
    {
	return c_typeinfo;
    }
    
} // End class definition for PTLineDescription
